searchData={"items":[{"type":"module","title":"HNSW","doc":"Documentation for `HNSW`.","ref":"HNSW.html"},{"type":"extras","title":"Changelog","doc":"# Changelog\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [Unreleased]","ref":"changelog.html"},{"type":"extras","title":"Added - Changelog","doc":"- Added new features","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- Changed an existing functionality","ref":"changelog.html#changed"},{"type":"extras","title":"Deprecated - Changelog","doc":"- Deprecated a feature so that it can be removed in a later release","ref":"changelog.html#deprecated"},{"type":"extras","title":"Removed - Changelog","doc":"- Removed a feature","ref":"changelog.html#removed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Fixed a bugfix","ref":"changelog.html#fixed"},{"type":"extras","title":"Security - Changelog","doc":"- Patched a security vulnerability\n\n[Unreleased]: https://github.com/probably-not/hnsw/compare/v0.1.0...HEAD\n[0.1.0]: https://github.com/probably-not/hnsw/releases/tag/v0.1.0","ref":"changelog.html#security"},{"type":"extras","title":"README","doc":"# HNSW\n\nA dead-simple pure Elixir Hierarchical Navigable Small World (HNSW) module.\n\n[You can read a deep dive explanation of HNSW here](https://www.pinecone.io/learn/series/faiss/hnsw/).","ref":"readme.html"},{"type":"extras","title":"Why? - README","doc":"The Elixir NX project has a project called [hnswlib](https://github.com/elixir-nx/hnswlib), which is a NIF wrapper around [the C++ hnswlib library](https://github.com/nmslib/hnswlib). While I love the fact that you can write NIFs in order to drop down to higher performing languages, and to bind to libraries that exist in these languages, I always tend to find myself having issues with NIFs. Sometimes it's because memory usage may not be properly reflected by the BEAM (since a NIF may not control the memory allocated by the library), sometimes the interface works in a non-intuitive way because the original library isn't necessarily compatible, tracing and the like is usually more problematic, and on top of all of that, there's a pretty big cognitive overhead to NIFs - you need to know the other language, and the other language is either C, C++, or Rust, all three of which are notoriously complex.\n\nSo, whenever I find myself seeing things that are only NIFs, I tend to want to find a pure Elixir version of the same thing. Sure, the performance might not be 100% on par (although you can get pretty much on par, see Jason versus jiffy for example), but at least the cognitive overhead is lower, the function can be traced with the BEAM, and other developers don't need to learn a brand new language just to use it.","ref":"readme.html#why"},{"type":"extras","title":"Installation - README","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `hnsw` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:hnsw, \"~> 0.1.0\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}